#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/stat.h>


int readmessage(int fd, char* buffer, int bufsize){
  unsigned int msgsize=0;
  if(read(fd,&msgsize,sizeof(unsigned int))<sizeof(unsigned int)){
    //fprintf(stderr,"erorr reading message length\n");
    return 1;
  }
  if(msgsize>bufsize){
    fprintf(stderr,"buffer too small: %d/%d\n",msgsize,bufsize);
    return 1;
  }
  do {
    int dif=read(fd,buffer,msgsize);
    if(dif<=0){
      fprintf(stderr,"error reading message\n");
      return 1;
    }
    msgsize-=dif;
    buffer+=dif;
  }while(msgsize);
  return 0;
}

void writemessage(int fd, const char* message){
  if(!message){
    fprintf(stderr,"error writing null message\n");
    return;
  }
  unsigned int msgsize=strlen(message)+1;
  if(write(fd,&msgsize,sizeof(unsigned int))<sizeof(unsigned int)){
    fprintf(stderr,"error writing message length\n");
    return;
  }
  do {
    int dif=write(fd,message,msgsize);
    if(dif<=0){
      fprintf(stderr,"error writing message\n");
      return;
    }
    msgsize-=dif;
    message+=dif;
  }while(msgsize);
}



int main(int argc, char** argz){
  char* home=getenv("HOME");
  if(argc<2){
    fprintf(stderr,"argument missing, try %s help\n",argz[0]);
    return 1;
  }
  if(!home){
    fprintf(stderr,"you are homeless, this can't be good\n");
    chdir("/tmp/");
  }else{
    chdir(home);
  }

  char* sockname=getenv("WINGMON_SOCK");
  if(!sockname)sockname=".wingedmonkey.sock";

  int sockfd = socket(AF_UNIX, SOCK_STREAM, 0);
  if (sockfd < 0){
    fprintf(stderr,"ERROR opening socket\n");
    return 1;
  }
  struct sockaddr_un serv_addr;
  serv_addr.sun_family = AF_UNIX;
  strcpy(serv_addr.sun_path,sockname);
  if(connect(sockfd,(struct sockaddr*)&serv_addr,sizeof(struct sockaddr_un))<0){
    close(sockfd);
    fprintf(stderr,"error connecting stream socket\n");
    return 2;
  }

  char buffer[4096];
  char* c=buffer;
  for(int i=1;i<argc;i++){
    //int count=sprintf(c,"%s ",argz[i]);
    int count=sprintf(c,"\037%s",argz[i]);
    if(count>0)c+=count;
  }

  writemessage(sockfd,buffer);


  while(!readmessage(sockfd,buffer,4096)){
    fputs(buffer,stdout);
    fputc('\n',stdout);
  }

  close(sockfd);
  return 0;
}
